// ciklus.h - Klasa ciklusa.

#ifndef _ciklus_h_
#define _ciklus_h_

#include "izraz.h"
using namespace Izrazi;
#include "naredba.h"

namespace Naredbe {
  class Ciklus: public Naredba {
    Izraz*   usl;                            // Uslov ciklusa.
    Naredba* nar;                            // Sadrzaj ciklusa.
    void kopiraj(const Ciklus& c)            // Kopiranje u ciklus.
      { usl = c.usl->kopija(); nar = c.nar->kopija(); }
    void premesti(Ciklus c) {                 // Premestanje u ciklus.
      usl = c.usl; nar = c.nar;
      c.usl = nullptr; c.nar = nullptr;
    }
    void brisi() { delete usl; delete nar; } // Oslobadjanje memorije.
    void pisi(ostream& it) const {           // Pisanje.
      Naredba::pisi(it); it << "while(" << *usl << ")\n";
      nivo++; it << *nar; nivo--;
    }
  public:
    Ciklus(const Izraz& u, const Naredba& n)  // Inicijalizacija.
      { usl = u.kopija(); nar = n.kopija(); }
    Ciklus(const Ciklus& s) { kopiraj(s); }   // Kopirajuci konstruktor.
    Ciklus(Ciklus&& s) { premesti(s); }       // Premestajuci konstruktor.
    ~Ciklus() { brisi(); }                 // Unistavanje ciklusa.
    Ciklus& operator=(const Ciklus& s) {   // Kopirajuca dodela vrednosti.
      if (this != &s) { brisi(); kopiraj(s); }
      return *this;
    }
    Ciklus& operator=(Ciklus&& s) {        // Premestajuca dodela vrednosti.
      if (this != &s) { brisi(); kopiraj(s); }
      return *this;
    }
    void izvrsi() const;                                 // Izvrsavanje.
    Ciklus* kopija() const { return new Ciklus(*this); } // Kopija.
  }; // class Ciklus
} // namespace Naredbe

#endif
