// crtez1.h - Klasa obojenih crteza.

#ifndef _crtez1_h_
#define _crtez1_h_

#include "pravoug3.h"
#include "niz4.h"

namespace Figure {
  class Crtez: public Pravoug {
    Niz<Figura*> figure;                 // Figure u crtezu.
    void kopiraj(const Crtez& crt);      // Kopiranje crteza.
    void brisi();                        // Unistavanje crteza.
  public:                                // Konstruktori.
    Crtez(const Tacka& T,
      double sir, double vis, Boja bb=Boja()):
      Pravoug(T, sir, vis, bb) {}
    Crtez(const Crtez& crt): Pravoug(crt) { kopiraj(crt); }
    ~Crtez() { brisi(); }                // Destruktor.
    Crtez& operator=(const Crtez& crt) { // Dodela vrednosti.
      if (this != &crt) {
        brisi(); Pravoug::operator=(crt); kopiraj(crt);
      }
      return *this;
    }
    Crtez* kopija() const override       // Kopija crteza.
      { return new Crtez(*this); }
    Crtez& dodaj(const Figura& fig)      // Dodavanje figure kopiranjem.
      { figure.dodaj(fig.kopija()); return *this; }
    Crtez& dodaj(Figura* fig)            // Dodavanje figure preuzimanjem.
      { figure.dodaj(fig); return *this; }
    Boja boja(const Tacka& T) const override; // Boja tacke.
  }; // class Crtez
} // namespace Figure

#endif

