// izvor.h - Klasa izvora elektricne energije.

#ifndef _izvor_h_
#define _izvor_h_

#include "potrosac1.h"
#include <iostream>
using namespace std;

 
namespace Potrosaci {
  class G_indeks{};                // KLASA GRESAKA: Indeks izvan opsega.
  inline ostream& operator<<(ostream& it, const G_indeks&)
    { return it << "*** Nedozvoljen indeks! ***"; }

  class G_preopt {};               // KLASA GRESAKA: Preopterecen izvor.
  inline ostream& operator<<(ostream& it, const G_preopt&)
    { return it << "*** Preopterecen izvor! ***"; }

  class Izvor {                                 // KLASA IZVORA:
    Potrosac** niz;                             // Niz potrosaca. 
    int kap;                                    // Broj prikljucnih mesta.
    double sna, opt;               // Nazivna snaga i trenutno opterecenje.
  public:
    Izvor(double s, int k);                     // Stvaranje izvora.
    Izvor(const Izvor&) =delete;                // Ne sme da se kopira.
    Izvor& operator=(const Izvor&) =delete;     // Ne sme da se dodeljuje.
    ~Izvor();                                   // Unistavanje izvora.
    double snaga() const { return sna; }        // Nazivna snaga izvora.
    double opterecenje() const { return opt; }  // Trenutno opterecenje.
    int brMesta() const { return kap; }         // Broj prikljucnih mesta.
    Izvor& prikljuci(Potrosac* p, int i);       // Prikljucivanje potrosaca.
    friend ostream& operator<<(ostream& it, const Izvor& izv); // Pisanje.
  }; // class
} // namespace

#endif

