// kvadrat.h - Klasa kvadrata u ravni.

#ifndef _kvadrat_h_
#define _kvadrat_h_

#include "figura1.h"

class Kvadrat: public Figura {
  Real a;                                           // Stranica.
public:
  Kvadrat(Real aa=1, const Tacka& tt=ORG)           // Konstruktor.
    : Figura(tt) { a = aa; }
  Real O() const override { return 4 * a; }         // Obim.
  Real P() const override { return a * a; }         // Povrsina.
  Kvadrat* kopija() const override                  // Dinamicka kopija.
    { return new Kvadrat(*this); }
private:
  void citaj(istream& ut) override                  // Citanje.
   { Figura::citaj(ut); ut >> a; }
  void pisi (ostream& it) const override {          // Pisanje.
    it << "kvadrat ["; Figura::pisi(it);
    it << ", a=" << a << ", O=" << O() << ", P=" << P() << ']';
  }
};

#endif

