// mnogougao1.h - Klasa mnogouglova u prostoru.

#ifndef _mnogougao1_h_
#define _mnogougao1_h_

#include "figura2.h"
#include "vektor3.h"

class GIndeks {}; // Klasa gresaka: Nedozvoljen indeks.

class Mnogougao: public Figura {
  Vektor* niz;                                       // Temena mnogougla.
  int     n;                                         // Broj temena.
  void pisi(ostream& it) const;                      // Pisanje.
  void kopiraj(const Mnogougao& m);                  // Kopiranje u objekat.
public:
  explicit Mnogougao(int k=3)                        // Stvaranje mnogougla.
    { niz = new Vektor [n = k]; }
  Mnogougao(const Mnogougao& m) { kopiraj(m); }      // Konstruktor kopije.
  ~Mnogougao() { delete [] niz; }                    // Destruktor.
  Mnogougao& operator=(const Mnogougao& m) {         // Dodela vrednosti.
    if (this != &m) { delete [] niz; kopiraj(m); }
    return *this;
  }
  Mnogougao* kopija() const                          // Kopiranje.
    { return new Mnogougao(*this); }
  Mnogougao& operator+=(const Vektor& v);            // Pomeranje mnogougla.
  Vektor teziste() const;                            // Teziste.
  Vektor& operator[](int i) {                // Pristupanje temenu:
    if (i<0 || i>=n) throw GIndeks();        // - promenljivog objekta,
    return niz[i];
  }
  const Vektor& operator[](int i) const {    // - nepromenljivog objekta.
    if (i<0 || i>=n) throw GIndeks();
    return niz[i];
  }
};

#endif
