// tekst3.h - Klasa tekstova.

#ifndef _tekst3_h_
#define _tekst3_h_

#include "objekat.h"
#include <cstring>
using namespace std;

class Tekst: public Obj {
  char* tks;                                   // Sadrzaj objekta.
  bool jednako(const Obj& obj) const           // Da li su jednaki?
    { return strcmp(tks, ((Tekst&)obj).tks) == 0; }
  void pisi (ostream& it) const                // Pisanje objekta.
    { it << '[' << (tks ? tks : "") << ']'; }
  void citaj(istream& ut);                     // Citanje objekta.
  void kopiraj(const char* niz);               // Kopiranje u objekat.
  void premesti(Tekst& t) {                    // Premestanje u objekat.
    tks = t.tks; t.tks = nullptr;
  }
 
public:
  Tekst(const char* niz="") { kopiraj(niz); }  // Inicijalizacija niskom.
  Tekst(const Tekst& t): Obj(t)                // Inicijalizacija tekstom
    { kopiraj(t.tks); }                        //   kopranjem.
  Tekst(Tekst&& t): Obj(t)                     // Inicijalizacija tekstom
    { premesti(t); }                           //   premestanjem.
  ~Tekst() { delete [] tks; }                  // Unistavanje objekta.
  Tekst& operator=(const Tekst& t) {       // Dodela vrednosti kopiranjem.
    if (this != &t) { delete [] tks; Obj::operator=(t); kopiraj(t.tks); }
    return *this;
  }
  Tekst& operator=(Tekst&& t) {            // Dodela vrednosti premestanjem.
    if (this != &t) { delete [] tks; Obj::operator=(t); premesti(t); }
    return *this;
  }
  string klasa() const override { return "Tekst"; }           // Ime klase.
  Tekst* kopija() const override { return new Tekst(*this); } // Kopija obj.
};

#endif

