// zbirfun.h - Klasa zbirova funkcija.

#ifndef _zbirfun_h_
#define _zbirfun_h_

#include "fun3.h"
#include <cmath>
using namespace std;

namespace Izvodi {
  class G_zbir_fun_pun {};          // KLASA GRESAKA: Zbir funkcija je pun.
  inline ostream& operator<<(ostream& it, const G_zbir_fun_pun&)
    { return it << "*** Zbir funkcija je pun! ***\n"; }

  class Zbir_fun: public Fun {      // KLASA ZBIROVA FUNKCIJA:
    Fun** niz;                      // Niz funkcija.
    int kap, duz;                   // Kapacitet i broj popunjenih mesta.
    void pisi(ostream& it) const override;     // Pisanje zbira funkcija.
    void kopiraj(const Zbir_fun&);             // Kopiranje u zbir funkcija.
    void premesti(Zbir_fun zf) {               // Premestanje u zbir funkc.
      niz = zf.niz; kap = zf.kap; duz = zf.duz;
      zf.niz = nullptr;
    }
    void brisi();                              // Oslobadjanje memorije.
  public:
    explicit Zbir_fun(int n=2)                 // Stvaranje zbira funkcija.
      { niz = new Fun* [kap = n]; duz = 0; }
    Zbir_fun(const Zbir_fun& zf) { kopiraj(zf); } // Kopirajuci konstruktor.
    Zbir_fun(Zbir_fun&& zf) { premesti(zf); }     // Premestajuci konstr.
    ~Zbir_fun() { brisi(); }                      // Unistavanje zbira funk.
    Zbir_fun& operator=(const Zbir_fun& zf){      // Kopirajuca dodela
      if (this != &zf) { brisi(); kopiraj(zf); }  //   vrednosti.
      return *this;
    }
    Zbir_fun& operator=(Zbir_fun&& zf){           // Premestajuca dodela
      if (this != &zf) { brisi(); premesti(zf); } //   vrednosti.
      return *this;
    }
    Zbir_fun& operator+=(const Fun& f) {          // Dodavanje funkcije
      if (duz == kap) throw G_zbir_fun_pun();     //   po vrednosti.
      niz[duz++] = f.kopija();
      return *this;
    }
    Zbir_fun& operator+=(Fun* f) {                // Dodavanje funkcije
      if (duz == kap) throw G_zbir_fun_pun();     //   po adresi.
      niz[duz++] = f;
      return *this;
    }
    double operator()(double x) const override;   // Vrednost zbira funkc.
    Delegat izvod() const override;               // Izvod zbira funkcija.
    Zbir_fun* kopija() const override             // Kopija zbira funkcija.
      { return new Zbir_fun(*this); }
  }; // class Zbir_fun
} // namespace Izvodi

#endif

